;Include for: PCPWM_SpCh_2.asm ;  2  16/01/2020
;   /  0    .
;SpeedChange_2	;   /   / PCPWM 
;  24 450/PCPWM_Accelerate  -   PCPWM_Accelerate,PCPWM_AccelCounter

;   2 ( -1       ):
;    -       ( ,   )
;      -  / /  .
;    /   PCPWM_Flag,3,ACCESS		; /
;        " " PCPWM_Flag1	;,F,ACCESS;;4=  --
;     
	Global SpeedMemoryKeys	;   3
SpeedMemoryKeys ;       
#define DoubleFreqKey	PortB_Buf,4,ACCESS	; 
#define HalfFreqKey 	PortB_Buf,3,ACCESS	; 
#define Mem_0_Key		PortB_Buf,1,ACCESS	;   
#define Mem_1_Key		PortB_Buf,2,ACCESS	;  

;   1   1    
	bcf	PCPWM_Flag,0,ACCESS;0=     LcdTask   
;TryKey_1	;   
	btfsc	DoubleFreqKey
		bra		TryKey_2
	bsf		_C	;	   
	rlcf	PCPWM_WrkSpdBuf,F,BANKED	;       
	btfsc	_C	;
	 setf	WREG,ACCESS
	bsf		WREG,0,ACCESS	;	   
	movwf	PCPWM_WrkSpdBuf,BANKED;       
		return;		bra		DoneKey_All
TryKey_2	;   
	btfsc	HalfFreqKey
		bra	TryKey_3
	bcf		_C	;	   
	rrcf	PCPWM_WrkSpdBuf,F,BANKED	;       
		bnz	DoneKey_All
	incf	PCPWM_WrkSpdBuf,F,BANKED	;WREG,W,ACCESS	;   
		return;		bra		DoneEditKey
TryKey_3	;  1
	btfsc	Mem_0_Key
		bra	TryKey_4
	movff	PCPWM_Speed_M0,PCPWM_WrkSpdBuf	;      
		return;		bra		DoneEditKey
TryKey_4	;  2
	btfsc	Mem_1_Key
		return;		bra		DoneEditKey
	movff	PCPWM_Speed_M1,PCPWM_WrkSpdBuf	;      
		return;		bra		DoneEditKey
DoneKey_All
;	movwf	PCPWM_WrkSpdBuf,BANKED;       
;DoneEditKey	
;KeyNotChanged
	return
RunKeys ;    
#define RevRunKey	Encoder_Buf,7,BANKED;PortB_Buf,7,ACCESS	;   7F 
#define ForwRunKey	Encoder_Buf,6,BANKED;PortB_Buf,6,ACCESS;    BF 

	bcf PCPWM_Flag,3,ACCESS	;;3= /  
	movf	PCPWM_SpCh_Route,W,BANKED	;
	sublw	0x3	; 3-Wreg
		bnn		DoneRunKey	;      >3
;  /      
	btfss	RevRunKey	;   = 1
		bra		DoneRunKey1 ;  
	btfss	ForwRunKey	;   = 1
		bsf PCPWM_Flag,3,ACCESS	;;3= /  
DoneRunKey1
	btfss	ForwRunKey	;
		bra		DoneRunKey2
	btfss	RevRunKey
		bsf PCPWM_Flag,3,ACCESS	;;3= /  
DoneRunKey2
	btfss	PCPWM_Flag,3,ACCESS	;;3= /
			return	;bra		DoneRunKey
;   -    
	movf	PCPWM_SpeedReal,W,BANKED	;     ?
		bnz		MotorRunning
	movb	RevRunKey,PCPWM_Flag,4,ACCESS;PortB_Buf,7,ACCESS	; / -    
			return	;bra		DoneRunKey
MotorRunning	; 
	bcf PCPWM_Flag1,4,ACCESS;;4=  --
;ReverseKeyPressed
	btfss	RevRunKey
		bra		ForwardKeyPressed
	btfss	PCPWM_Flag,4,ACCESS	; / -    
		bsf PCPWM_Flag1,4,ACCESS;;4=  --    
			return;	bra			DoneRunKey
ForwardKeyPressed
	btfss	ForwRunKey	; 
		bra		DoneRunKey
	btfsc	PCPWM_Flag,4,ACCESS	; / -    
		bsf PCPWM_Flag1,4,ACCESS;;4=  --    
DoneRunKey
	return

SpeedChange2	;   /   / PCPWM 
;	nop

#ifdef __DEBUG	; 18/01/2020         -  ( )
	bsf PCPWM_Flag,0,ACCESS;0=     LcdTask   
	bcf	PortB_Buf,7,ACCESS	;   7F 
	bsf PortB_Buf,6,ACCESS;    BF 
	;btfsc	PCPWM_Flag,7,ACCESS	;   ?
; bra	MainLoop
#endif


 	; *************************  2     ******************
	btfsc	PCPWM_Flag,0,ACCESS;0=     LcdTask   
		rcall	SpeedMemoryKeys	;     1  
	rcall	RunKeys	;    -  
		Extern	CaseGoTo,SpCh_R0_0,SpCh_R1_0,SpCh_R2_0,SpCh_R3_0,SpCh_R5_0,SpCh_R6_0
		Extern	StopKeyNotPressed_0
	movf	PCPWM_SpCh_Route,W,BANKED	;
 call	CaseGoTo	;   WREG    4   GoTo  Call

	Extern	SpCh_R0_0,SpCh_R1_0,SpCh_R2_0,SpCh_R3_0;   0 
 goto	SpCh_R0_0 ; 0.  ,     .
 goto	SpCh_R1_0 ; 1.    ,  -   .
 goto	SpCh_R2_0 ; 2.  ,  ,   ,
 goto	SpCh_R3_0 ; 3.       0.7 
		goto	SpCh_R4 ; 4.        2
 goto	SpCh_R5_0 ; 5.  - 0.1    ,
 goto	SpCh_R6_0 ; 6.     IRAMX   ,
  		goto	SpCh_R7 ; 7. //        ,

SpCh_R4 ; 4.    
 
SpCh_R4_KeyWait
	btfsc	PCPWM_Flag,3,ACCESS	;;3= /
	  bra SpCh_R4_Next
	btfss	PCPWM_Flag1,4,ACCESS;;4=  --
  		retlw	0x37		;   

SpCh_R4_Next
	PWM_Start	;   PWM   
;	bcf	PCPWM_Flag1,1,ACCESS;1=   "  /"
;	bsf PCPWM_Flag,3,ACCESS;;3= /
	bsf	PCPWM_Flag,6,ACCESS;6=   RealStop PCPWM Module -       
	movlf 0x1,PCPWM_SpeedReal,BANKED;    =1   .
;     " "      PCPWM 
	clrf    OVDCONS,ACCESS	;      
	movlw	b'11101010'	;  3   
	andwf	OVDCOND,F,ACCESS
 
 incf	PCPWM_SpCh_Route,F,BANKED	;   ""
	movff	Tic_100_Counter,Alarm_DelayStamp	;   
		retlw	0x38 ;     

SpCh_R7 ; 7. //        ,
 	btfsc	PCPWM_Flag,3,ACCESS	;;3= /
		goto	StopKeyNotPressed_0
;
StopMotor_1
	bsf	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
;	bcf		PCPWM_Flag,3,ACCESS	; /  
	bcf	PCPWM_Flag1,4,ACCESS;   ;4=  --
	clrf	PCPWM_WorkSpeed,BANKED;   

StopKeyNotPressed
	goto	StopKeyNotPressed_0

