; ********** GENERATED Common Init File Created 12/06/2020 12:57:36.00 
; *******************  Begin File Main\Init_Main.inc ***************** 
;    

;	movlf	Init_TRISA,TRISA,ACCESS	;   	Define_Main_3F.inc
	movlf	Init_TRISB,TRISB,ACCESS	;   	Define_Main_3F.inc
	movlf	Init_TRISC,TRISC,ACCESS	;   	Define_Main_3F.inc
 #ifdef	TRISD
	movlf	Init_TRISD,TRISD,ACCESS	;   	Define_Main_3F.inc
 #endif
;	movlf	Init_TRISE,TRISE,ACCESS	;   	Define_Main_3F.inc


	clrf	STKPTR,ACCESS		;       ?
;    -    ( ) -     .

;   2 -   ,     
;   -          
;    . 

;         
	lfsr	2,0x0		; DATA Stack Pointer initialize - Begin of RAM
;	clrf	PRODL,ACCESS	; Counter init LSB
;	movlf	0x3,PRODH,ACCESS; Counter init MSB
ClearLoop
	clrf	POSTINC2,ACCESS	;  
;	decfsz	PRODL,F,ACCESS	;  
;		bra		ClearLoop	; 
;	decfsz	PRODH,F,ACCESS	; 
	btfss	FSR2H,2			;    DS39616B-page 71
		bra		ClearLoop	;  
 
	lfsr	2,0x2ff		; DATA Stack Pointer initialize - top of RAM
;   1 -   ,     UART
	;lfsr	1, 1-ware,   ; Usart_Rx_Buf	; USART Rx Buff
;   0 () -  ,      
;    . 
	;lfsr	0,0x2ff		; LCD_Task  Math_BCD  EePromSync  1-Ware,  .

	DefaultBankSelect	;   
	
	movlf	b'01110011',OSCCON,ACCESS	;  RC 8  ,   SLEEP.
;	movlf	b'01110011',OSCCON,ACCESS	;  RC 8  .
;	movlf	b'01110011',OSCCON,ACCESS	;  RC 8  .
;	movlf	b'01110011',OSCCON,ACCESS	;  RC 8  .

 	LED0_Output	; TRIS Macro
	LED0_Clear
 	LED1_Output	; TRIS Macro
	LED1_Clear
  
	clrf	TBLPTRU,ACCESS		;<64    
	clrf	WREG_Restore,BANKED	; 
	clrf	TOSL_Restore,BANKED	; 
	clrf	TOSH_Restore,BANKED	;  
	clrf	TOSU_Restore,BANKED	;   
	movlf	0x09,Restore_Counter,BANKED	;   "".
; *******************  Begin File EPROM\Init_EPROM.inc ***************** 
;*************  EPROM ***********************
 extern	EPROM_Read	; -       
	bcf		INTCON,GIEH,ACCESS	;    
	bcf		INTCON,GIEL,ACCESS	;    
	EPROM_Page ; BSR for EPROM Task
 call EPROM_Read	;       .
;*************   EPROM ***********************
; *******************  Begin File Beeper\Init_Beeper.inc ***************** 
 Beeper_Output	; Clear beeper TRIS macro
 clrf	Beep,ACCESS	;  - 
 btfss	RCON,3,ACCESS	;   ?
 	decf	Beep,F,ACCESS	;  - 
 ; *******************  Begin File Interrupt\Init_Interrupt.inc ***************** 
;        Main.asm
;	bsf		INTCON,GIEL,ACCESS		;    ; *******************  Begin File LCD_Key_Enc\Init_LCD_Key_Enc.inc ***************** 
;    
;********************** LCD 44780  , ,   *******************
	LCD_BANK	;    

 bcf LCD_TRIS_RS	; 
 bcf LCD_TRIS_RW	; 
 bcf LCD_TRIS_E		; 
; bcf LCD_TRIS_E1	; 
	LCD_KeyInp	;  RA6

TRISE      EQU  H'0F96'	;    28 
 setf	TRISE,ACCESS	;      


	;clrf	LCD_Ctrl_TRIS,ACCESS		;   -   
	bcf		LCD_RS			;
	bcf		LCD_RW			;
	bcf		LCD_E			;

	;setf	LCD_Key_TRIS,ACCESS		
	clrf	Flag1,ACCESS			;    - .
	clrf	LCD_Flg,ACCESS			;    - .
	clrf	LCD_Flg1,ACCESS			;    - .
	clrf	LCD_Flg2,ACCESS			;    - .

	clrf	Flag1,ACCESS			;    - .
	clrf	KeyBuf,ACCESS			;     - .
	clrf	Encoder_Count,ACCESS	;     - .
	;clrf	PortbIntCount,ACCESS	;
	;clrf	PortbIntCount+1,ACCESS	;
	;clrf	ErrCode,BANKED			;   - 
	clrf	LcdWorkTime,ACCESS		; - - 
 bsf		LCD_Flg1,3,ACCESS		;  / 
 movlf	d'5',EncSubStrNum,BANKED; /   
; setf NewKeyBits,ACCESS;    
;; *******************  Begin File 1W\Init_1W.inc ***************** 
;   1-W
;    
	W1_Page	;     1-Wire

; **********************   0 *******************************
;       1-  -5
;      

	clrf	T0CON,ACCESS				; 16    12  
	bsf		T0CON,T0PS0,ACCESS		;   1/4,   = 1/3 
	bcf		T0CON,T016BIT,ACCESS		;     -   -0 8 
	;bsf		T0CON,T0PS1,ACCESS		;  1/8
	;bsf		T0CON,T0PS2,ACCESS		;  1/32 -  ,   .

	bcf		INTCON,TMR0IF,ACCESS		;  	
	bsf		INTCON,TMR0IE,ACCESS		;  45     .
	bcf		T0CON,TMR0ON,ACCESS		;   
	clrf	TMR0H,ACCESS	;   
	clrf	TMR0L,ACCESS	;     
	;bsf		T0CON,T0PS0,ACCESS		;  
	;bsf		T0CON,T0PS2,ACCESS		;  1/64 - 2,85 ,   5   .
;bsf		T0CON,TMR0ON,ACCESS		;   0x6D84  5 

	bsf		INTCON2,TMR0IP,ACCESS	; TMR0  / 10/03/2017	
; **********************    0 *******************************


; **********************  1-Wire  *******************************

	clrf	W_1_Flg,ACCESS			;    - .
	clrf	Int_T5_Route,ACCESS		;   5  - 
	incf	Int_T5_Route,F,ACCESS	;   5  =1
	clrf	DS1820_ScratctPad+14,BANKED; 
	clrf	DS1820_ScratctPad+15,BANKED; 
	clrf	W1_TimeStamp,BANKED		;
	clrf	W1_AlgRoute,BANKED	;  , 0=  1- 
	incf	W1_AlgRoute,F,BANKED	;  , 1=   
	incf	W1_AlgRoute,F,BANKED	;  , 2=    
	;incf	W1_AlgRoute,F,BANKED	;  , 3=    
	clrf	DS1820_Err_CRC,BANKED; 
; **********************   1-Wire  *******************************

;         -   
;        " 1-"    .
;*************************************
	;clrf	W1_Byte_Return,ACCESS	;
	;movff	W1_Route_Temp,W1_Route	;
	bsf		W_1_Flg,0,ACCESS		;  1-Wire  ,   ,   1-W,
	;movlf	0x55,W_1_WriteBuf,BANKED
	clrf	W1_Route,BANKED

;*************************************
; *******************  Begin File PCPWM_3F\Init_PCPWM_3F.inc ***************** 
				PCPWM_Page	;   PCPWM
;  PC_PWM   
;  3    3   PWM  4431
;   IRAMX16UP60A  .
;  , / ,
;   . 
;17.1 Control Registers ;The operation of the PWM module is controlled by a
;total of 22 registers. Eight of these are used to
;configure the features of the module:
; PWM Timer Control register 0 (PTCON0)
; PWM Timer Control register 1 (PTCON1)
; PWM Control register 0 (PWMCON0)
; PWM Control register 1 (PWMCON1)
; Dead Time Control register (DTCON)
; Output Override Control register (OVDCOND)
; Output State register (OVDCONS)
; Fault Configuration register (FLTCONFIG)
;There are also 14 registers that are configured as
;seven register pairs of 16 bits. These are used for the
;configuration values of specific features. They are:
; PWM Time Base Registers (PTMRH and PTMRL)
; PWM Period Registers (PTPERH and PTPERL)
; PWM Special Event Compare Registers
;(SEVTCMPH and SEVTCMPL)
; PWM Duty Cycle #0 Registers
;(PDC0H and PDC0L)
; PWM Duty Cycle #1 Registers
;(PDC1H and PDC1L)
; PWM Duty Cycle #2 Registers
;(PDC2H and PDC2L)
; PWM Duty Cycle #3 registers
;(PDC3H and PDC3L)
;All of these register pairs are double-buffered.

	CLRF PDC0H,ACCESS ;   
	movlf	0x1F,PDC0L,ACCESS ; Period/PWM Freq Set
	CLRF PDC1H,ACCESS ;   
	movlf	0x1F,PDC1L,ACCESS ; Period/PWM Freq Set
	CLRF PDC2H,ACCESS ;   
	movlf	0x1F,PDC2L,ACCESS ; Period/PWM Freq Set


;     
;  IRAMX16UP60A     48/4096=11718,75    .
; AN955   - UP/Down  .
;   - PTPER=0x1FF  11    11.7 .
;    11.7  23.4    
; DUTY CYCLE UPDATE TIMES IN UP/DOWN COUNTING MODE WITH DOUBLE UPDATES

;	CLRF PTPERH,ACCESS ; ; 48 MHz 12 MIPS 1FFh 11 bits 11.7/23.4 kHz
;	INCF PTPERH,F,ACCESS ;  -    
;	INCF PTPERH,F,ACCESS ;      
;	INCF PTPERH,F,ACCESS ; --    .
;	movlf	0x01,PTPERH,ACCESS	; 0x1FF = 11 bits 11.718/23.4 kHz    
;****************
;	movlf	0x03,PTPERH,ACCESS	; 0x3FF = 12 bits 5.859/11.718 kHz    
;	setf PTPERL,ACCESS ; Period/PWM Freq Set 
;  PTPER  4   PDC.
;     DTCon (  ~0.1     DTCon)
; -    PDC = 
;  = DtCon+1,  = PtPer*4-DtCon-FloatChargeTime
;    -        ,
;   -  2-3 .  DT = 2   STK_621_061_E -  6-8 
;    .
;         :
; 1. PTPER-16,	2. PDC_Max-16 	3. PDC_Min-8 -    
; 4.   -16	5.   -16
; 6. PCPWM_MK1+1 ; .     12 
; 10    16  = 160   + 3    4  (45-72-90-120 ). 	 
#ifdef	PCPWM_FreqHi 	; 11.7   , 11  - 
	movlf	0x02,PTPERH,ACCESS	; -    
 movlf	0xA,PCPWM_MK1+1,BANKED; .     12  	 

 #else	;  5.8 , 12  - 
	movlf	0x0F,PTPERH,ACCESS	; -     
 movlf	0x14,PCPWM_MK1+1,BANKED; .     13 	 
 ;movlf	0x0A,PCPWM_MK1+1,BANKED; .     12 	 
 ;movlf	0x05,PCPWM_MK1+1,BANKED; .     11 	 
 #endif
;	movlf	0x4,PTPERL,ACCESS ; .      . 
	movlf	0xFF,PTPERL,ACCESS ; .      . 
    movlf	0x00,PCPWM_MK1+0,BANKED;      

; *******         *******.
;     FXM1680U  ?
; 1616=32   16    .65536-13107=52 428 :
;  14    16384  -  = 10240=0x2800,  2 418   0x804 
;  13    8 192  -  = 5120=0x1400,  5 836.6   0x404
;  12    4 096  -  = 2560=0xA00,  11 628   0x204
;  11    2 048  -  = 1280=0x500,  23 076   0x104
;  10    1 024  -  = 640=0x280,  ~46    0x84
; 02/10/2018    0xA00   0x204 -   ,
; -      .


;REGISTER 17-1: PTCON0: PWM TIMER CONTROL REGISTER 0
;bit 7-4 PTOPS3:PTOPS0: PWM Time Base Output Postscale Select bits
;0000 =1:1 Postscale ;0001 =1:2 Postscale ..... ;1111 =1:16 Postscale 
;bit 3-2 PTCKPS1:PTCKPS0: PWM Time Base Input Clock Prescale Select bits
;00 =PWM time base input clock is Fosc/4 (1:1 prescale)
;01 =PWM time base input clock is Fosc/16 (1:4 prescale)
;10 =PWM time base input clock is Fosc/64 (1:16 prescale)
;11 =PWM time base input clock is Fosc/256 (1:64 prescale)
;bit 1-0 PTMOD1:PTMOD0: PWM Time Base Mode Select bits
;11 =PWM time base operates in a Continuous Up/Down mode with interrupts for double PWM
;updates.
;10 =PWM time base operates in a Continuous Up/Down Counting mode.
;01 =PWM time base configured for Single-shot mode.
;00 =PWM time base operates in a Free Running mode.
	clrf PTCON0,ACCESS	;   
	bsf  PTCON0,PTMOD1,ACCESS ; PTMOD1:PTMOD0:
;           -    
;	bsf  PTCON0,PTMOD0,ACCESS ; PTMOD1:PTMOD0:  23    .
	; 10 =PWM time base operates in a Continuous Up/Down Counting mode.
;REGISTER 17-2: PTCON1: PWM TIMER CONTROL REGISTER 1
;bit 7 PTEN: PWM Time Base Timer Enable bit
;1 = PWM time base is ON
;0 = PWM time base is OFF
;bit 6 PTDIR: PWM Time Base Count Direction Status bit
;1 = PWM time base counts down.
;0 = PWM time base counts up.
;bit 5-0 Unimplemented: Read as 0.
	clrf PTCON1,ACCESS			;   
	bsf  PTCON1,PTEN,ACCESS ;1 = PWM time base is ON
;REGISTER 17-3: PWMCON0: PWM CONTROL REGISTER 0
;bit 7 Unimplemented: Read as 0.
;bit 6-4 PWMEN2:PWMEN0: PWM Module Enable bits(1)
;111 =All odd PWM I/O pins enabled for PWM output(2).
;110 =PWM1, PWM3 pins enabled for PWM output.
;101 =All PWM I/O pins enabled for PWM output(2) .
;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
;011 =PWM0, PWM1, PWM2 and PWM3 I/O pins enabled for PWM output.
;010 =PWM0 and PWM1 pins enabled for PWM output.
;001 =PWM1 pin is enabled for PWM output.
;000 =PWM module disabled. All PWM I/O pins are general purpose I/O.
;bit 3-0 PMOD3:PMOD0: PWM Output Pair Mode bits
;For PMOD0:
;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
;0 = PWM I/O pin pair (PWM0, PWM1) is in the Complementary mode.
;For PMOD1:
;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
;0 = PWM I/O pin pair (PWM2, PWM3) is in the Complementary mode.
;For PMOD2:
;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.
;0 = PWM I/O pin pair (PWM4, PWM5) is in the Complementary mode.
;For PMOD3(3):
;1 = PWM I/O pin pair (PWM6, PWM7) is in the Independent mode.
;0 = PWM I/O pin pair (PWM6, PWM7) is in the Complementary mode.
	clrf PWMCON0,ACCESS			;   
	;bsf  PWMCON0,PWMEN1,ACCESS ;;010 =PWM0 and PWM1 pins enabled for PWM output.
;	bsf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
 PWM_Start	;    
	;bsf  PWMCON0,PMOD0,ACCESS ;;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
	;bsf  PWMCON0,PMOD1,ACCESS ;;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
	;bsf  PWMCON0,PMOD2,ACCESS ;;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.

;REGISTER 17-4: PWMCON1: PWM CONTROL REGISTER 1
	clrf PWMCON1,ACCESS			;   
;bit 7-4 SEVOPS3:SEVOPS0: PWM Special Event Trigger Output Postscale Select bits
;0000 =1:1 Postscale ;0001 =1:2 Postscale ..... ;1111 =1:16 Postscale
;bit 3 SEVTDIR: Special Event Trigger Time Base Direction bit
;1 = A special event trigger will occur when the PWM time base is counting downwards.
;0 = A special event trigger will occur when the PWM time base is counting upwards.
;bit 2 Unimplemented: Read as 0.
;bit 1 UDIS: PWM Update Disable bit
;1 = Updates from duty cycle and period buffer registers are disabled.
;0 = Updates from duty cycle and period buffer registers are enabled.
;bit 0 OSYNC: PWM Output Override Synchronization bit
;1 = Output overrides via the OVDCON register are synchronized to the PWM time base.
;0 = Output overrides via the OVDCON register are asynchronous.

;REGISTER 17-5: DTCON  DEAD TIME CONTROL REGISTER
;	clrf DTCON,ACCESS			;   
;bit 7-6 DTPS1:DTPS0: Dead Time Unit A Prescale Select bits
;11 = Clock source for Dead Time Unit is FOSC/16.
;10 = Clock source for Dead Time Unit is FOSC/8.
;01 = Clock source for Dead Time Unit is FOSC/4.
;00 = Clock source for Dead Time Unit is FOSC/2.
;bit 5-0 DT5:DT0: Unsigned 6-bit dead time value bits for Dead Time Unit.
	movlf	0x18,DTCON,ACCESS	;  1     48/2 

;REGISTER 17-6: OVDCOND: OUTPUT OVERRIDE CONTROL REGISTER
;R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1
;POVD7(1) POVD6(1) POVD5 POVD4 POVD3 POVD2 POVD1 POVD0
;bit 7-0 POVD7:POVD0: PWM Output Override bits(1)
;1 = Output on PWM I/O pin is controlled by the value in the Duty Cycle register and the PWM
;time base.
;0 = Output on PWM I/O pin is controlled by the value in the corresponding POUT bit.	
	setf OVDCOND,ACCESS			;   
	clrf OVDCONS,ACCESS			;   

;REGISTER 17-8: FLTCONFIG: FAULT CONFIGURATION REGISTER
;R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0
;BRFEN FLTBS(1) FLTBMOD(1) FLTBEN(1) FLTCON FLTAS FLTAMOD FLTAEN
;bit 7 BRFEN: Breakpoint Fault Enable bit
;1 = Enable fault condition on a breakpoint (i.e., only when HDMIN = 1)
;0 = Disable fault condition
;bit 6 FLTBS: Fault B Status bit(1)
;1 = FLTB is asserted;
;if FLTBMOD = 0, cleared by the user
;if FLTBMOD = 1, cleared automatically at beginning of the new period when FLTB is
;deasserted
;0 = No Fault
;bit 5 FLTBMOD: Fault B Mode bit(1)
;1 = Cycle-by-cycle mode: Pins are inactive for the remainder of the current PWM period, or until
;FLTB is deasserted. FLTBS is cleared automatically when FLTB is inactive (no fault present).
;0 = Inactive mode: Pins are deactivated (catastrophic failure) until FLTB is deasserted and
;FLTBS is cleared by the user only.
;bit 4 FLTBEN: Fault B Enable bit(1)
;1 = Enable Fault B
;0 = Disable Fault B
;bit 3 FLTCON: Fault Configuration bit
;1 = FLTA , FLTB or both deactivates all PWM outputs
;0 = FLTA or FLTB deactivates PWM[5:0]
;bit 2 FLTAS: Fault A Status bit
;1 = FLTA is asserted;
;If FLTAMOD = 0, cleared by the user
;If FLTAMOD = 1, cleared automatically at beginning of the new period when FLTA is
;deasserted.
;0 = No Fault
;bit 1 FLTAMOD: Fault A Mode bit
;1 = Cycle-by-cycle mode: Pins are inactive for the remainder of the current PWM period, or until
;FLTA is deasserted. FLTAS is cleared automatically.
;0 = Inactive mode: Pins are deactivated (catastrophic failure) until FLTA is deasserted and
;FLTAS is cleared by the user only.
;bit 0 FLTAEN: Fault A Enable bit
;1 = Enable Fault A
;0 = Disable Fault A
;
	clrf FLTCONFIG,ACCESS			;   

; movlf	0x15,PCPWM_Speed,BANKED	;  
; movlf	0x85,PCPWM_Amp,BANKED	;  		 
	
 clrf	PCPWM_Err,ACCESS	;   
;	movlb	0x0	; BSR  Bank-1 for PCPWM 
 ;clrf	PCPWM_Ang1,BANKED;	:2	;      BANK 0
 ;clrf	PCPWM_Ang1+1,BANKED;	:2	;      BANK 0
	PCPWM_Page
	clrf	PCPWM_Flag2,ACCESS		;
 btg PCPWM_Flag2,1,ACCESS;1=       
	clrf	PCPWM_Flag1,ACCESS		;
	clrf	PCPWM_Flag,ACCESS		;

	clrf	PCPWM_SpCh_Route,BANKED	;
	movlf	WorkSubStr,PCPWM_Alarm_Route,BANKED;   
 	clrf	PCPWM_SpdCount,BANKED
	clrf	PCPWM_SpdCount+1,BANKED	;
	clrf	PCPWM_AnimeCount,BANKED	;   
 movlf	d'13',PCPWM_AnimeSubStr,BANKED	;
 movlf	d'8',PCPWM_StartStop,BANKED		;
 movlf	d'10',PCPWM_ForwardReverse,BANKED;
 movlf	d'10',PCPWM_AccelProt,BANKED;   /   
 movff PCPWM_AccelProt,PCPWM_AccProtBuf	;
; movlf	d'1',PcPwmAngInd,BANKED;    	
; movlf	d'10',PcPwmFrqInd,BANKED;    0-20, 6074  = 10 ,12  
 		;setf	PcFrqIndOld,BANKED;     0-20, 0xFF =  


	clrf	PCPWM_WorkSpeed,BANKED;     .
 #ifdef __DEBUG
	bsf	PCPWM_Flag,3,ACCESS		; /
 ;call StopMotor	; 
 #else
	bcf	PCPWM_Flag,3,ACCESS		; /
 call StopMotor	; 
 #endif
;   
	bsf		IPR3,PTIP,ACCESS		;  /
	bcf		PIR3,PTIF,ACCESS		;   
	bcf		PIE3,PTIE,ACCESS		;   - PCPWM

	btfsc	RCON,3,ACCESS	;   ?
 bra NotWdtReset
 	bsf PCPWM_Flag1,3,ACCESS;3= 0=     50 ,
;      /   
	movlf	d'18',PCPWM_Alarm_Route,BANKED;    - 18 
NotWdtReset
;	return
; PTMOD ???	
;This mode is available in Up/Down Counting mode. In
;the Double Update mode (PTMOD<1:0> = 11),
;Do not change PTMOD while PTEN is
;active. It will yield unexpected results. To
;change PWM Timer mode of operation,
;first clear PTEN bit, load PTMOD with
;required data and then set PTEN.; *******************  Begin File RTK\Init_RTK.inc ***************** 
;************************ RTCinit ********************************
			RTK_Page	;   Real Time Keep
	CLRF secs,ACCESS ; Initialize timekeeping registers
	CLRF mins,ACCESS ;
	CLRF hours,ACCESS ;
	CLRF days,ACCESS ;
	CLRF Tic_10,ACCESS ; Clear tics

  #ifdef	RTK_ADC_Source	; 18 750   
; TAD=CLC/32 ADC=20*TAD=640*CLC 
; Interrupt=4*ADC=2560 CLC
; CLC=48 000 000 / 2 560 = 18 750 Hz Interrupt from ADC
; CLC=50 000 000 / 2 560 = 19 531.25 Hz Interrupt from ADC
; 19 531 / 19= 1 027.9605 Hz
; 19 531 / 195 = 100.1602 Hz
;  ""   1   ,  
;   1      . 

	movlf ADC_Divisor,Tic_18750,BANKED;  19,  986  1027    
;	movlf	d'188',Tic_1000,BANKED;  187,  100,26    48 
	movlf	ADC_Div100,Tic_1000,BANKED;  195,  100,16    50 
	movlf low(ADC_Div10),Tic_100,BANKED;10 tics LSB
	movlf high(ADC_Div10),Tic_100+1,BANKED;10 tics MSB

  #else	; 1000   
;**********;;  1  RTK **************
;      
;   1000   1    ( ), 10    100
	clrf	T1CON,ACCESS
	bsf		T1CON,RD16,ACCESS	; 16  
;	bsf		T1CON,T1CKPS1,ACCESS; 1/4 
;	bsf		T1CON,T1CKPS0,ACCESS ; 1/8 

	MOVLW 0x80 ; Preload TMR1 register pair
	MOVWF TMR1H,ACCESS 	; for 1 second overflow
	CLRF TMR1L,ACCESS	;
;	MOVLW b00001111 ; Configure for external clock,
;	MOVWF T1OSC ; Asynchronous operation, external oscillator
;*****************************************

	movlf	d'10',Tic_1000,BANKED
	movlf	d'10',Tic_100,BANKED
	

;*******************************************************************************************	
	bcf		IPR1,TMR1IP,ACCESS	; TMR1  
	bcf		PIR1,TMR1IF,ACCESS	;   .
	bsf		PIE1,TMR1IE,ACCESS	;   183     .	
	bsf		T1CON,TMR1ON,ACCESS	;  183 


  #endif

;************* -5     *************
 setf	PR5H,ACCESS 	; 
 setf	PR5L,ACCESS		; 
 clrf	TMR5H,ACCESS	; 
 clrf	TMR5L,ACCESS	; 
;REGISTER 14-1: T5CON: TIMER5 CONTROL REGISTER
;R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0
;T5SEN RESEN T5MOD T5PS1 T5PS0 T5SYNC TMR5CS TMR5ON
 clrf	T5CON,ACCESS ; Reset State
;bit 7 										  bit 0
;bit 7 T5SEN: Timer5 Sleep Enable bit(1)
;1 = Timer5 enabled during Sleep
;0 = Timer5 disabled during Sleep
;bit 6 RESEN: Special Event Reset Enable bit
;1 = Special Event Reset disabled
;0 = Special Event Reset enabled
 bsf T5CON,NOT_RESEN,ACCESS  ;     
;bit 5 T5MOD: Timer5 Mode bit
;1 = Single-Shot mode enabled
;0 = Continuous Count mode enabled
;	 bsf T5CON,T5MOD,ACCESS  ;  / 
;bit 4:3 T5PS1:T5PS0: Timer5 Input Clock Prescale Select bits
;11 =1:8 ;10 =1:4 ;01 =1:2 ;00 =1:1
; bsf T5CON,T5PS1,ACCESS	;   1/4,   = 1/3 
; bsf T5CON,T5PS0,ACCESS	;   

;bit 2 T5SYNC: Timer5 External Clock Input Synchronization Select bit
;When TMR5CS = 1:
;1 = Do not synchronize external clock input
;0 = Synchronize external clock input
;When TMR5CS = 0:
;This bit is ignored. Timer5 uses the internal clock when TMR5CS = 0
;bit 1 TMR5CS: Timer5 Clock Source Select bit
;1 = External clock from pin T5CKI
;0 = Internal clock (TCY)
;bit 0 TMR5ON: Timer5 On bit
;1 = Timer5 enabled
;0 = Timer5 disabled
 bsf T5CON,TMR5ON,ACCESS ;  Timer
;Note 1: For Timer5 to operate during Sleep mode, T5SYNC must be set.
;	bsf		IPR3,TMR5IP,ACCESS	;   5  
;	bcf		PIR3,TMR5IF,ACCESS	;    	
;	bsf		PIE3,TMR5IE,ACCESS	;   5 




	; *******************  Begin File ADC\Init_ADC.inc ***************** 
;****************************ADC 4431 Init ***************************************************************	

;    4431   .
; 10 ,  , TAD=CLC/32 TAQ=0
;   1000   1 
;   AN0
;         4 .
;    -       
; .   5 , 1     4 
; -.
;     4 
	
	ADC_Page	; BSR for ADC Task

		clrf	ADCON0,ACCESS
		bsf		ADCON0,ADON,ACCESS			;   ,  5-10 
		bsf		ADCON0,ACSCH,ACCESS	; 1 = Multi-Channel mode Enabled, Single Channel mode Disabled
		bsf		ADCON0,ACONV,ACCESS	;Auto-Conversion Continuous Loop or Single-shot Mode Select bit
		bsf		ADCON0,ACMOD0,ACCESS;01 =Sequential Mode2 (SEQM2). Four samples are taken in sequence:
;1st sample: Group A 2nd sample: Group B 3rd sample: Group C 4th sample: Group D
; Single shoot, Single channel,Single Ch Mode1 (SCM1). Group A is taken and converted 
		clrf	ADCON1,ACCESS				
; bit 7-6 VCFG<1:0>: A/D VREF+ and A/D VREF- Source Selection bits
; 00 =VREF+ = AVDD, VREF- = AVSS, (AN2 and AN3 are Analog inputs or Digital I/O)
; bit 4 FIFOEN 0 = FIFO is disabled
		bsf		ADCON1,FIFOEN,ACCESS	;1 = FIFO is enabled
 		clrf	ADCON2,ACCESS				
; bit 7 ADFM: A/D Result Format Select bit 0 = Left justified
; bit 6-3 ACQT<3:0>: A/D Acquisition Time Select bits
; 0000 = No Delay(1) (Conversion starts immediately when GO/DONE is set)

;bit 2-0 ADCS<2:0>: A/D Conversion Clock Select bits
;000 = FOSC/2 ;001 = FOSC/8 ;010 = FOSC/32
;011 = FRC/4(2) ;100 = FOSC/4 ;101 = FOSC/16
;110 = FOSC/64 ;111 = FRC (Internal A/D RC Oscillator)
;Note 1: If the A/D clock source is selected as RC, a time of TCY is added before sampling/
;conversion starts.
;2: Due to an increased frequency of the internal A/D RC oscillator, FRC/4 provides clock
;frequencies compatible with previous A/D modules.
;3: In sequential mode TACQ should be 12 TAD or greater.
;

; bit 2-0 ADCS<2:0>: A/D Conversion Clock Select bits 000 = FOSC/2 001 = FOSC/8 
; minimum TAD = 380-385 ns. 48/16=333 ,  
;  -         .
;  40-48-50   :
; 
#ifdef __DEBUG;*******   
	bsf		ADCON2,ADCS2,ACCESS			; 101= TAD= CLC/16 = 2 uS
;	bsf		ADCON2,ADCS0,ACCESS			; 101= TAD= CLC/16 = 2 uS
	bsf	ADCON2,ADCS1,ACCESS	; 110 = 48/64=0.75 1333+ ns
#else
;	bsf		ADCON2,ADCS2,ACCESS			; 101= TAD= CLC/16 = 2 uS
;	bsf		ADCON2,ADCS0,ACCESS			; 101= TAD= CLC/16 = 2 uS
	bsf	ADCON2,ADCS1,ACCESS	; 010 = 48/32=1.5 600+ 
							; = 50/32 = 640 
#endif



;0001 = 2 TAD 0010 = 4 TAD 0011 = 6 TAD 0100 = 8 TAD 0101 = 10 TAD 0110 = 12 TAD
;0111 = 16 TAD	896		13392.85714		209.2633929
;; 	23 437,5  -       
;;    PCPWM  EPROM -  26/01/2019
;    8  1    -    .
;       PCPWM 
	clrf	WREG,ACCESS	;    
	bsf	WREG,ACQT0,ACCESS	; 0001 = 2 TAD = 1.2 
	bsf	WREG,ACQT1,ACCESS	; 0010 = 4 TAD = 2.4 
	bsf	WREG,ACQT2,ACCESS	; ACQ= 100 = 8*TAD= 16 uS
;	bsf	WREG,ACQT3,ACCESS	; ACQ= 1000 = 20*TAD= 16 uS
	iorwf	ADCON2,F,ACCESS	;      

;	bsf	ADCON2,ACQT3,ACCESS	; ACQ= 1000 = 20*TAD= 16 uS

;  20-12    (2.4 ), 20  * 32  = 640 , 2560  , 18750  
; 
;      -     - ACQT0-3        
;  ,      .     :
;3: In sequential mode TACQ should be 12 TAD or greater.
; 75    , 18750  , 293   
; -       20     32   .
;  18750    10 -   1/10         .
; 1/100     ,      - 
; 1/1000       ,      - .

;03/04/2018 -       40-64 TAD ( 258 EQUATION 21-3: CONVERSION TIME FOR MULTI-CHANNEL MODES)
;Sequential Mode:T = (TACQ)A + (TCON)A + [(TACQ)B  12 TAD] + (TCON)B + [(TACQ)C  12 TAD] + (TCON)C + [(TACQ)D  12 TAD] + (TCON)D
;Simultaneous Mode:T = TACQ + (TCON)A + (TCON)B + TACQ + (TCON)C + (TCON)D

;0001 = 2 TAD	448		26785.71429		418.5267857
;0010 = 4 TAD	512		23437.5		366.2109375
;0011 = 6 TAD	576		20833.33333		325.5208333
;0100 = 8 TAD	640		18750			292.96875
;0101 = 10 TAD	704		17045.45455		266.3352273
;0110 = 12 TAD	768		15625			244.140625
; 		31 250  -       
;0111 = 16 TAD	896		13 392.85714		209.2633929
;0111 = 16-12 TAD 512	24 414.0625		381,469726
;; 	23 437,5  -       
;1000 = 20 TAD	1024	11 718.75		183.1054688
;1000 = 20-12 TAD 640	18 750 		292.96875 -   48 
;1000 = 20-12 TAD 640	19 531.25 	305.17578125 -   50 
;1001 = 24-12 TAD 768	15 625 	
;1001 = 24-12 TAD 768	16 276 		  50  -        .
;         24  16 .	
;1010 = 28-12 TAD 1280	13 392.857		146.484375	; 26 785.714  Simultaneous Mode
;1011 = 32-12 TAD 1408	11 718.75		133.1676136	; 23 437.500  Simultaneous Mode
;1100 = 36 TAD	1536	7812.5			122.0703125	; 20 833.333  Simultaneous Mode
;1101 = 40 TAD	1664	7211.538462		112.6802885	; 18 750  Simultaneous Mode
;1110 = 48 TAD	1920	6250			97.65625	; 15 625  Simultaneous Mode
;1111 = 64 TAD	2432	4934.210526		77.09703947	; 11 718.750  Simultaneous Mode
;    16 /64   -    ?

	bsf	ADCON2,ADFM,ACCESS	; bit 7 ADFM: A/D Result Format Select bit 0 = Left justified
			;     010 = FOSC/32
;	bsf		ADCON2,ADCS0,ACCESS			; 
;	bsf		ADCON2,ACQT2,ACCESS			; ACQ= 100 = 8*TAD= 16 uS
;	bcf		ADCON2,ACQT1,ACCESS			;   
;	bcf		ADCON2,ACQT0,ACCESS			;  


 		clrf	ADCON3,ACCESS			;
;ADRS=00 (int on each word) , SSRC=0000	(all triggers disabled)
	bsf		ADCON3,ADRS1,ACCESS			; 10 =Interrupt is generated when the 4th word is written to the buffer

 #ifdef ANSEL1	; 4431
	setf	ANSEL0,ACCESS		; PortA -   
	setf	ANSEL1,ACCESS		; AN8 =  
	setf	TRISA,ACCESS		; PortA =  
	setf	TRISE,ACCESS		; PortE =  
 #else	; 2431
	movlf	b'10001111',ANSEL0,ACCESS	; PortA -  4  
	movwf	TRISA,ACCESS		; PortA =  

 #endif

		
;		bcf		TRISA,RA4,ACCESS	; AN4 = RA4 = Digital Input
	

	bcf		ANSEL0,ANS4,ACCESS	; AN4 = RA4 = Digital Input
;	bsf		ANSEL0,ANS1,ACCESS	; AN1 = RA1 = Analog Input
#ifdef ANSEL1	; 4431
 #ifdef __DEBUG;*******  
	bcf		ANSEL0,ANS6,ACCESS	; AN6 = RE0 = Digital Input
	bcf		ANSEL0,ANS7,ACCESS	; AN7 = RE1 = Digital Input
	clrf	ANSEL1,ACCESS		; AN8 = RE2 = Digital Input
 #endif
#endif
;	bsf		ANSEL0,ANS6,ACCESS	; AN6 = RE0 = Analog
;	bsf		ANSEL0,ANS7,ACCESS	; AN7 = RE1 = Analog

 		clrf	ADCHS,ACCESS			;  8  - 2   4 ,
;   RA4/AN4/Cap3/QEB
;GDSEL=00=AN3, GBSEL=00=AN1, GCSEL=00=AN2, GASEL=00=AN0
;     /  2--3-4  .
;     0 (  8),   1  5,       6  7.
;	bsf		ADCHS,GDSEL0,ACCESS			; = 01 =AN7(1) 
;	bsf		ADCHS,GCSEL0,ACCESS			; = 01 =AN6(1) 


	bsf		ADCON0,ADON,ACCESS		;  
	;   
		bcf		IPR1,ADIP,ACCESS	;  /
	bcf		PIR1,ADIF,ACCESS		;   
	bsf		PIE1,ADIE,ACCESS		;   - 
	bsf		ADCON0,GO_DONE,ACCESS	;    
;            
	movlf	.32,ADC_Counter,BANKED	;   
	movlf	.64,ADC_Counter2,BANKED	;   
	clrf	ADC_ERR_Counter,ACCESS			;
	clrf_N	ADC_Buff+0x0,BANKED,0xF	; 
	clrf	Adc_AmpPeak,BANKED	;  
	clrf	Adc_VoltPeak,BANKED	;  
	clrf	Adc_TempPeak,BANKED	; //
;	clrf	ADC_Buff+0x3,BANKED	;
;	clrf	ADC_Buff+0x4,BANKED	;
;	clrf	ADC_Buff+0x5,BANKED	;
;	clrf	ADC_Buff+0x6,BANKED	;
;	clrf	ADC_Buff+0x7,BANKED	;
;	clrf	ADC_Buff+0x8,BANKED	; 
;	clrf	ADC_Buff+0x9,BANKED	;  
;	clrf	ADC_Buff+0xA,BANKED	; 
;	clrf	ADC_Buff+0xB,BANKED	;
;	clrf	ADC_Buff+0xC,BANKED	;
;	clrf	ADC_Buff+0xD,BANKED	;
;	clrf	ADC_Buff+0xE,BANKED	;
;	clrf	ADC_Buff+0xF,BANKED	;
;

; *******************  Begin File Math\Init_Math.inc ***************** 
;*************  Math ***********************
; extern	EPROM_Read	; -       
; call EPROM_Read	;       .
;*************   Math ***********************
 Math_Page	; BSR for Math Task
	clrf	Math_Step,BANKED;
	clrf	Math_ErrCount,BANKED;
	clrf	B_Arg+0,BANKED	;
  incf	B_Arg+0,F,bnk		;
	clrf	B_Arg+1,BANKED	;

	clrf	A_ArgBuf+0,BANKED	;
  incf	A_ArgBuf+0,F,bnk		;
	clrf	A_ArgBuf+1,BANKED	;
;	clrf	Math_Step,BANKED;

	clrf	Math_Cmd,ACCESS	;
	clrf	Math_Flag,ACCESS;

 #ifdef Math_Present
	bsf	Math_Flag,0,ACCESS	;    
 #endif ; Math_Present

