;******************************************************************************
;    Filename: RTOS_ADC_4431.asm                                               *
;    Date:  28/03/2017                                                                   *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;        
;       .
;           
;     .
;     - .
;    -    
;         .
	#include Define.h	;    
;*******************************
;    -   
 #ifdef	ADC_Present
;*******************************
		Extern	Restore_ML	;      
 #ifdef	PCPWM_Present
	Extern MotorFault
 #endif
ADC	code
		;      NOP
	goto	Restore_ML		;       -  

 global	ADC_Task	;
ADC_Task	;	
 ADC_Page	; BSR for Math Task

 btfsc ADC_Flag,3,ACCESS;   ?
	bra	ADC_Steps	;	 
 btfsc ADC_Flag,1,ACCESS;      
	bra	ADC_FirstBuff
 btfsc ADC_Flag,2,ACCESS;      
	bra	ADC_SecondBuff
 bcf ADC_Flag,0,ACCESS;    
		return	;
ADC_FirstBuff
; **********   1//1    ************
;							 ADC_Out+0/2/4/6 
 movlf	d'0',ADC_Step,BANKED;	  ""  
 bsf 	ADC_Flag,3,ACCESS;   
	bra	ADC_Steps1	;
;		return	;
; **********   2//2    ************
;							 ADC_Out+8/A/C/E 
ADC_SecondBuff
 movlf	d'5',ADC_Step,BANKED;	  ""  
 bsf 	ADC_Flag,3,ACCESS;   
	bra	ADC_Steps1	;

 #include Proj_Dir\ADC\ADC_Step.inc	; BRA   

;		return	;
;		return	;

;*******************************
;    -   
 #endif	; #ifdef	Math_Present
;*******************************

; #ifdef ADC_Present
; #endif
;

;End of program
		END

