; ********** GENERATED Common Define File Created 12/06/2020 12:57:36.00 
; *******************  Begin File Main\Define_Main.inc ***************** 
	nolist
;      -   
; #include Proj_Dir\_Out\Define_All.inc	;    

#Define	CompGoToTest Yes ;   
#Define	DelayCuriosityTest Yes ;    


#define LED0_Pin 		6
	#ifdef	LED0_Pin
#define LED0_PORT 		LATB
#define LED0_TRIS 		TRISB
#define Debug_LED0		LED0_PORT,LED0_Pin,ACCESS
#define LED0_Output	bcf	LED0_TRIS,LED0_Pin,ACCESS
#define LED0_Set	bcf	Debug_LED0	;   +5 
#define LED0_Clear	bsf	Debug_LED0	; 
#define LED0_Toggle	btg	Debug_LED0
	#else
#define LED0_Output	nop
#define LED0_Set	nop
#define LED0_Clear	nop
#define LED0_Toggle	nop
	#endif


#define LED1_Pin 		7
	#ifdef	LED1_Pin
#define LED1_PORT 		LATB
#define LED1_TRIS 		TRISB
#define Debug_LED1		LED1_PORT,LED1_Pin,ACCESS
#define LED1_Output	bcf	LED1_TRIS,LED1_Pin,ACCESS
#define LED1_Set	bsf	Debug_LED1
#define LED1_Clear	bcf	Debug_LED1
#define LED1_Toggle	btg	Debug_LED1
	#else
#define LED1_Output	nop
#define LED1_Set	nop
#define LED1_Clear	nop
#define LED1_Toggle	nop
	#endif


;#define Debug_Key0 		PORTE,0,0
;#define Debug_Key1 		PORTE,1,0
;#define Debug_Key2 		PORTE,3,0

#Define Beeper		movlw		; -,     
#Define	LcdOutStr	movlw	;        LCD





; *******************  Begin File EPROM\Define_EPROM.inc ***************** 
;************************* Begin EPROM Define file **********************************
#define EPROM_Present	Yes		;
#define EPROM_Page		movlb	0x1	; BSR  Bank-1 for EPROM Task
;#define ParametrStor	d'7'	;    
;#define FsrLoadParam	lfsr	0,TimAdd;Par_T1	; -0  

;#ifdef	W1_Pin	;     -   
	#define ParametrCmn	d'24';      
;#else
;	#define ParametrCmn	d'22';      1-W
;#endif
;     
#define ParamBlockNum d'16';    
#define ParamBlockLen d'14';    
; *******************  Begin File Beeper\Define_Beeper.inc ***************** 
#define Beeper_Present Yes
;#define Beeper_Tone Yes
; Ground---Beeper---||--<==>---BeeperPin
;           20R    1mkF 200R    500 Hz
; Multiplex BEEPER and Blue or White LED and Green SuperBright LED: 
; Gnd---|<|(0.5V)-100R-GLED(2.1V)-Middle2BeperPin-BLED(2.5V)-100R-|<|(0.5V)---VDD +5V
; TriState BeeperPin allow Off 2 led and On LED individually.
; Pin and port:
#ifdef	PORTD	;4431
 #define Beeper_TRIS	TRISD
 #define Beeper_Lat		LATD
 #define Beeper_Port	PORTD
 #define Beeper_Pin		4
#else			;2431
 #define Beeper_TRIS	TRISC
 #define Beeper_Lat		LATC
 #define Beeper_Port	PORTC
 #define Beeper_Pin		6	; RC6 = Beeper
#endif

#define BeeperPin	 	Beeper_Lat,Beeper_Pin,ACCESS
; Macros for sound:
#define Beeper_Output	bcf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Input		bsf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Clear		bcf	BeeperPin
;#define Beeper_Set		bsf	BeeperPin
#define Beeper_Toggle	btg	BeeperPin
#define Beeper_Page		movlb	0x1	; BSR  Bank-1 for Beeper Task

  #ifdef Beeper
	#undefine Beeper
  #endif
Beeper	macro	ArgA	; 8 bit input
	movlw	ArgA		; 
	addwf	Beep,F,ACCESS	; 
;	;Beeper_Toggle				; 
	endm
;  - ,     
;         -  .
;   -      
;          .
;   -   -   .

; *******************  Begin File Interrupt\Define_Interrupt.inc ***************** 
#define Int_Low_Present Yes

; Int_Low
;           20R    1mkF 200R    500 Hz
; Pin and port:



; *******************  Begin File LCD_Key_Enc\Define_LCD_Key_Enc.inc ***************** 

 #ifdef	DelayCuriosityTest	; 07/03/2020   
#define ParametrNum		d'30'	;    
 #else ; #ifdef	DelayCuriosityTest	;
#define ParametrNum		d'29'	;    
 #endif ; #ifdef DelayCuriosityTest	;


#define ParamDelta		d'21'	;      
#define WorkSubStr		d'61';d'13'	;    
#define CyrTable	Yes			;       Win1251  HD44780

;     - LCD 
#define LCD_BANK movlb	0x1	; BSR  1  LCD
;#define Print_Page movlb 0x0; BSR  0    -   
#define LCD_Present		YES	; 
#define LCD_Work_Present YES;   
#define LCD_TimeOut_Work .12;        
#define LCD_TimeOut_Service	.3;         
;    #define LCD_Debounce_TimeOut .30;  /      

#define LCD_BCD_BANK movlb	0x1	; BSR  1  BIN_2_BCD


#ifdef	PORTD ;; 18F4431,  2431  
 
 #define LCD_Key_Port	PORTD	
 #define LCD_Key_Lat	LATD
 #define LCD_Ctrl_Port	PORTD
 #define LCD_Ctrl_TRIS	TRISD
 #define LCD_Key_TRIS	TRISD

 #define LCD_RS	 		LCD_Key_Lat,7,ACCESS; 04  LCD
 #define LCD_RW	 		LCD_Key_Lat,6,ACCESS; 05  LCD
 #define LCD_E	 		LCD_Key_Lat,5,ACCESS; 06  LCD

#define LCD_TRIS_RS		LCD_Ctrl_TRIS,7,ACCESS
#define LCD_TRIS_RW		LCD_Ctrl_TRIS,6,ACCESS
#define LCD_TRIS_E		LCD_Ctrl_TRIS,5,ACCESS

#else ; 18F2431
 

 #define LCD_Key_Port	PORTC	
 #define LCD_Key_Lat	LATC
 #define LCD_Ctrl_Port	PORTC
 #define LCD_Ctrl_TRIS	TRISC
 #define LCD_Key_TRIS	TRISC
 #define LCD_InKey_Port	PORTA	

 #define LCD_RS	 		LCD_Key_Lat,5,ACCESS; 04  LCD
 #define LCD_RW	 		LCD_Key_Lat,4,ACCESS; 05  LCD
 #define LCD_E	 		LATA,4,ACCESS;  06  LCD
 #define LCD_InKey 		LCD_InKey_Port,6,ACCESS;  10  = RA6 

 #define LCD_TRIS_RS	LCD_Ctrl_TRIS,5,ACCESS
 #define LCD_TRIS_RW	LCD_Ctrl_TRIS,4,ACCESS
 #define LCD_TRIS_E		TRISA,4,ACCESS

#endif

#define LCD_Key_Port0	LCD_Key_Port,0,ACCESS
#define LCD_Key_Port1	LCD_Key_Port,1,ACCESS
#define LCD_Key_Port2	LCD_Key_Port,2,ACCESS
#define LCD_Key_Port3	LCD_Key_Port,3,ACCESS
#define LCD_Key_Port4	LCD_Key_Port,3,ACCESS
#define LCD_Key_Port5	LCD_Key_Port,3,ACCESS

#define LCD_Key_Lat0	LCD_Key_Lat,0,ACCESS
#define LCD_Key_Lat1	LCD_Key_Lat,1,ACCESS
#define LCD_Key_Lat2	LCD_Key_Lat,2,ACCESS
#define LCD_Key_Lat3	LCD_Key_Lat,3,ACCESS

#define LCD_Key_TRIS0	LCD_Key_TRIS,0,ACCESS
#define LCD_Key_TRIS1	LCD_Key_TRIS,1,ACCESS
#define LCD_Key_TRIS2	LCD_Key_TRIS,2,ACCESS
#define LCD_Key_TRIS3	LCD_Key_TRIS,3,ACCESS

#define LCD_Key_Mask01	b'00001111';    SET
#define LCD_Key_Mask10	b'11110000';    Clear




;#define LCD_Ctrl_TRIS3	LCD_Ctrl_TRIS,0,ACCESS

;#define LCD_E1	 		LATB,0,ACCESS
#define LCD_KeyInp		bsf	TRISA,6,ACCESS	;    
#define LCD_Enc0 		LCD_Ctrl_Port,7,ACCESS;  
#define LCD_Enc1 		LCD_Ctrl_Port,6,ACCESS;    


#define First_RAM_Addr			0	;   ,    
;     -  Accsess RAM  =0.
#ifdef	__DEBUG
	#define Debug_LCD_Busy 		1 	;     , 1=
#else
	#define Debug_LCD_Busy 		0 	;     , 1=
#endif

#define Short_Lcd_Bus		1	; 1= LCD 4  - .
#define Nibble_Lcd_Bus		YES	; 1= LCD 4       - .
 .if	Short_Lcd_Bus == 1
#define LCD_First_Init	0x28 ;      44780
 .else
#define LCD_First_Init	0x38 ;      44780
 .endif

;#define LCD_Init 		Flag1,0,0 
;#define Dl1_Flg 		Flag1,1,0 
#define Encoder_Step	0x1 ;   ,   3

;       4  -   
; 8  .   -     .
;     ""     
;  -      . 

 #ifdef	LcdOutStr		; 
	#undefine	LcdOutStr	; 
 #endif						;  
LcdOutStr	macro	NumChan; WREG  ,  
	movwf	LCD_ComBuf+NumChan,ACCESS
	bcf		LCD_Flg,4,ACCESS		;     
	bsf		LCD_Flg2,NumChan,ACCESS		;     
	endm
LcdOutStr1	macro	NumChan;    WREG  
	local	EndMacro
	btfss	LCD_Flg,4,ACCESS	; ,  LCD
		bra		EndMacro
	clrf	LCD_Pos,ACCESS	;      
	movwf	LCD_Com,ACCESS	; 
	clrf	LCD_Com+1,ACCESS;    / .
	bcf		LCD_Flg,4,ACCESS		;     
EndMacro
	endm
 ; *******************  Begin File 1W\Define_1W.inc ***************** 
; 1-Wire Definitions Pin and Macro
#define W1_Page		movlb	0x0	; BSR  Bank-0 for 1-W  Task
#define	Timer0_Present	Yes	;      

#ifdef	__DEBUG
	#define Debug_1W	 	1 	;   5, , 1= 
#else
	#define Debug_1W	 	0 	;   5, , 1= 
#endif

#define MaxW1Pointer	d'45'	;   1-Wire

 #ifdef	PORTD	;4431
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			0	; 15  4431
 #else			;2431
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			7	; 18  2431
 #endif

#define W1_Clear		bcf	W1_Lat,W1_Pin,ACCESS
#define W1_Set			bsf	W1_Lat,W1_Pin,ACCESS
#define W1_Output		bcf	W1_TRIS,W1_Pin,ACCESS
#define W1_Input		bsf	W1_TRIS,W1_Pin,ACCESS

;     1-Wire:
;  - 1 ROM  - 1  Functional 

#define DS1820_SEARCHROM 		0xF0	; ROM  
#define DS1820_SKIP_ROM			0xCC	; ROM  
#define DS1820_READROM 			0x33	; ROM  
#define DS1820_MATCHROM 		0x55	; ROM  
;#define DS1820_ALARMSEARCH 	0xEC	; ROM  

;#define DS1820_WRITE_SCRATCHPAD 0x4E; Functional 
#define DS1820_READ_SCRATCHPAD	0xBE ; Functional 
;#define DS1820_COPY_SCRATCHPAD 0x48 ; Functional 
;#define DS1820_READ_EEPROM 	0xB8 ; Functional 
;#define DS1820_READ_PWRSUPPLY 	0xB4 ; Functional 
#define DS1820_CONVERT_T		0x44 ; Functional 
;#define DS1820_FAMILY_CODE_DS18B20      0x28
;#define DS1820_FAMILY_CODE_DS18S20      0x10

; *******************  Begin File PCPWM_3F\Define_PCPWM_3F.inc ***************** 
#define PCPWM_Present Yes	;  - 
#define PCPWM_Page		movlb	0x1	; BSR  Bank-1 for PCPWM 

#ifdef __DEBUG;*******   -    ?
 #define PCPWM_1PhCalc Yes	;     -  1   .
#else
 #define PCPWM_1PhCalc Yes	;    -  1   .
#endif

#define PCPWM_12b	 Yes	; 12    8  -   
#define PCPWM_3H	 Yes	;  3    1/4   12  1/2  -   
#define PCPWM_DC_Corr Yes	;     DC -   
;#define PCPWM_Board Yes	;    /  
#define PCPWM_IRAMY Yes	;      ITRIP -   PWM .
;#define PCPWM_FreqHi Yes	; 11.7    11  (   12 ) - 
;     
;#define PCPWM_NoReverseKey Yes	;  ""   "   -0"
#define PCPWM_CoSinus Yes	;  ~2        ~10 
 #define FrqLen 6 ;   -  3   
;#define PCPWM_Dbg12b	 Yes	;  12   

IRAM_Stop macro		; 
; IRAMY       
;    2    RA0/An0  RA1/AN1
;  2        .
#ifdef	PCPWM_IRAMY ;;  IRAMX IRAMY    
	bcf		LATA,0,ACCESS	;     
	bcf		TRISA,0,ACCESS	;    
 #else	;  IRAMX
	bsf		LATA,0,ACCESS	;     
	bcf		TRISA,0,ACCESS	;    
 #endif
	endm	

ITRIP_Stop macro		;
	IRAM_Stop	; 2        .
;	bsf  PWMCON0,PMOD0,ACCESS ;;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
;	bsf  PWMCON0,PMOD1,ACCESS ;;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
;	bsf  PWMCON0,PMOD2,ACCESS ;;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.
;	clrf OVDCOND,ACCESS	;0 = Output on PWM I/O pin is controlled by the value in the corresponding POUT bit.	
; clrf OVDCONS,ACCESS	;   
;
;	bcf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
	clrf PWMCON0,ACCESS			;   
 setf	LATB,ACCESS	;   
	movlf	Init_TRISB,TRISB,ACCESS	;    	
 bcf PCPWM_Flag1,5,ACCESS;5=  /    (    )		
	endm	
PWM_Start macro		;
;  -   
	setf OVDCOND,ACCESS			;   
	clrf OVDCONS,ACCESS			;   
	clrf PWMCON0,ACCESS			;   
	bsf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
	movff	DtConBuf,WREG		;   
	movwf	DTCON,ACCESS		;    WREG   
#ifdef	PCPWM_IRAMY ;;  IRAMX IRAMY    
	bcf		LATA,0,ACCESS	;     
 #else	;  IRAMX
	bsf		LATA,0,ACCESS	;     
 #endif
;    
;	nop
;	nop
;	nop
;	nop
	bsf		TRISA,0,ACCESS	;    
	endm	
MoveEditToWorkSpeed	 macro		;;    
 local	ADC_Speed,EndMacro	; 
	btfsc	PCPWM_Flag1,6,ACCESS;   ;6=   ADC-0   
	bra	ADC_Speed
 movff	PCPWM_WrkSpdBuf,PCPWM_WorkSpeed;****    
	bra	EndMacro
ADC_Speed
	movff ADC_Out+1,WREG	;    
	rrcf	WREG,W,ACCESS	;   2
	bcf		WREG,7,ACCESS	;    
	andlw	0x80	;      
	movff	WREG,PCPWM_WorkSpeed;
EndMacro
	endm	


#ifdef PCPWM_Board ;       
 ;       .
 ;#define PCPWM_StartVoltage 0x80
 ;          .
 #define PCPWM_StartCurrent 0xF2 
 ;        .
 #define PCPWM_StartTermistor 0xF2 
#else ;       - , , 
 ;       .
 ;#define PCPWM_StartVoltage 0xA0
 ;          .
 #define PCPWM_StartCurrent 0x2 
 ;        .
 #define PCPWM_StartTermistor 0xB2 
#endif


;; Pin and port:
;#define Beeper_TRIS		TRISD
;#define Beeper_Lat		LATD
;#define Beeper_Port		PORTD
;#define Beeper_Pin		4
;#define BeeperPin	 	Beeper_Lat,Beeper_Pin,ACCESS
;; Macros for sound:
;#define Beeper_Output	bcf	Beeper_TRIS,Beeper_Pin,ACCESS
;;#define Beeper_Input		bsf	Beeper_TRIS,Beeper_Pin,ACCESS
;;#define Beeper_Clear		bcf	BeeperPin
;;#define Beeper_Set		bsf	BeeperPin
;#define Beeper_Toggle	btg	BeeperPin

;
; *******************  Begin File RTK\Define_RTK.inc ***************** 
;#define Timer1_Present Yes
#define RTK_ADC_Source Yes
#define RTK_Present Yes
#define RTK_Page		movlb	0x1	; BSR  Bank-1 for RTK Task
;RTK_Page	; BSR for RTK Task

; 18 750   24 414.0625   12M/640 or 12.5M/512
; TAD=CLC/32 ADC=20*TAD=640*CLC  16*TAD = 512 * CLC
; Interrupt=4*ADC=2560 CLC
; CLC=48 000 000 / 2 560 = 18 750 Hz Interrupt from ADC
; CLC=50 000 000 / 2 560 = 19 531.25 Hz Interrupt from ADC
; CLC=50 000 000 / 2 048 = 24 414.0625 Hz Interrupt from ADC ******* Now Use This
; 19 531 / 19= 1 027.9605 Hz
; 19 531 / 195 = 100.1602 Hz


;  ""   1   ,  
;   1      . 
#define ADC_Divisor d'25'  ;      1  = 1017.25260416666
#define ADC_Div100  d'245' ;      100  = 100.0576331
;   -  - .     +  .
; 2442 =  60    53  -    ~ 1.13
; 2722 =  = 60    60,74  -    = 
; 2688 =  60   59,74  =   
; 2697 + 2704 =    60  60,12 .
#define ADC_Div10   d'2697' ;      10  = 10.0016642
#define ADC_Div_1   d'2704' ;      1  ,
;    1   9*2441+2445=24 414,  = 1.00000256000655 



; *******************  Begin File ADC\Define_ADC.inc ***************** 
;     -       
 #define ADC_Present		Yes
;     -  26/03/2017
 #define ADC_Page		movlb	0x2	; BSR  Bank-2 for ADC Task
 #define ADC_ChannelSelect	b'01010110';   ADCHS: A/D CHANNEL SELECT REGISTER
 #define ADCHS_TestBit	1	;     
;ADC_Page	; BSR for ADC Task
; *******************  Begin File Math\Define_Math.inc ***************** 
;************************* Begin Math Define file **********************************
#define Math_Present	Yes		;
;    29/03/2017
;   22/03/2020
#define Math_Page		movlb	0x2	; BSR  Bank-2 for EPROM Task
#define	Math_MaxSteps	10	;   

