; ********** GENERATED Common Data Table File Created 12/06/2020 12:57:36.00 
; *******************  Begin File EPROM\Table_EPROM.inc **************** 
;   ,   .
;       ,
;   . 
;       - 
;      
;#ifdef	W1_Pin
;	#define ParametrCmn	d'16';      
;#else
;	#define ParametrCmn	d'14';      1-W
;#endif
;;     
;#define ParamBlockNum d'16';    
;#define ParamBlockLen d'13';    
;;     :
; dw	PCPWM_MotorNum	;  
;    Parameters_PSW_12b.xls/Param
;    EPROM\EPROM_RegsAdr.inc
;  PCPWM_3F\Parameters_PSW_12b.xls
	global	EPROM_Table_End,EPROM_Table;
EPROM_Table 
  dw PCPWM_MotorNum; 1=  0-15
  dw LCD_DebounceTimeOut; 2= 
  dw LCD_6_4; 3= 4 

;  09/06/2020       
  dw PCPWM_SpdMin;	4= )     
  dw PCPWM_SpdDelta;5= )       
  dw PCPWM_K_Prop;	6= )    
  dw PCPWM_K_Integr;7= )    
  dw PCPWM_K_Diff;	8= )    
  dw PCPWM_Alrm_Tim;9= )      
  dw Adc_Corr+5;	10=) AN   
  dw Adc_Corr+4;	11=) AN   

  dw Adc_Corr+3; 12=  
  dw Adc_Corr+2; 13= 
  dw Adc_Corr+1; 14=  
  dw Adc_Corr+0; 15= 
  
  dw Par_V; 16= 
  dw Par_VS;17=  
  dw Par_T; 18=  
	#ifdef	W1_Pin
  dw Par_K; 19=W1 Temp
  dw Par_K1; 20=W1 temp1
	#endif

 ;22/03/2020  
 ; dw PcDC_VN; 14=  DC  
  dw PcDC_Kf; 21= DC 

  dw PcPwmTopDT	; 22 =        
  dw DtConBuf; 23 =DTCON 0-63  
  dw DelayCuriosityIndex; 24=Delay Curiosity
;    
; 
;     
  dw PCPWM_Speed; 1= 
  dw PCPWM_Amp; 2=V/F Amp
  dw PCPWM_VFStart; 3=V/F Start
  dw PCPWM_Accelerate; 4=Accelerate
  dw Par_A; 5=
  dw PCPWM_MaxSpdIndx; 6=  
  dw PcPwmFrqInd; 7=  0-20
  dw PcPwmAngInd; 8=   0-3
  dw PCPWM_AutoStart; 9=  -127:127
  dw PcPwmProg; 10=   

;22/03/2020  
;  dw PcDC_Kf; 11= DC 
 dw PcDC_VN; 11=  DC 

;09/06/2020     
  dw Par_UV; 12=  (  )

  dw PCPWM_Speed_M0; 13=   1
  dw PCPWM_Speed_M1; 14=   2
EPROM_Table_End
;
; *******************  Begin File LCD_Key_Enc\Table_LCD_Key_Enc.inc **************** 
;*********    -    .
 #include Proj_Dir\LCD_Key_Enc\LCD_Text_FA.inc	;    .

 #include Proj_Dir\LCD_Key_Enc\LCD_Text_0-5.inc	;      

 #include Proj_Dir\LCD_Key_Enc\LCD_Enc_Text.inc	;      

 #include Proj_Dir\LCD_Key_Enc\LCD_SubStr.inc	;   

;**********    ; *******************  Begin File 1W\Table_1W.inc **************** 
;*************************Table_1W.h Begin **********************
	global	Table_1W

Table_1W	;   1-wire 
		db	d'0',d'3'	;     
#ifdef PCPWM_Board ;       
		db	0x28,0x47,0x51,0xEE,0x09,0x00,0x00,0x64	;   1
		db	0x28,0x59,0x20,0xED,0x09,0x00,0x00,0x04	;   2
		db	0x28,0x5B,0x76,0x39,0x01,0x00,0x00,0x49	;   0724C3-422AE    
#else ;       - , , 
		db	0x28,0x47,0x51,0xEE,0x09,0x00,0x00,0x64	;   1
		db	0x28,0x59,0x20,0xED,0x09,0x00,0x00,0x04	;   2
		db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
#endif
;**** End

; *******************  Begin File PCPWM_3F\Table_PCPWM_3F.inc **************** 
;************ PCPWM_Table **********************
	global	TabPwmFreq
TabPwmFreq	;        - 21 
  #include Proj_Dir\PCPWM_3F\PwmTab.inc	; 21   ~ 12  = 252 

	global	TabDeltAngle	;    
TabDeltAngle;     - 4  (45/72/90/120 )
  #include Proj_Dir\PCPWM_3F\AngTab.inc	; 4   3  = 12 

	global	Table_Sinus,Tab_SinEnd		;
Table_Sinus	;   816    1112  
;     1/4    3   

 #ifdef	PCPWM_12b ; 12    8  -   
;	 ~2      -   
; .
;		Table_Sinus       code   0x0001f2    program   0x001b84
;       Table_Sinus       code   0x0001f2    program   0x001392
	errorlevel  -311 ; 		Message[311] 



#ifdef	PCPWM_CoSinus; Yes	;  ~2        ~10 

#ifdef	PCPWM_Dbg12b	;  12  

   #ifdef	__DEBUG		;    DeBug
; 25/01/2020   12   / 11    'Sin T_123_16'!O5:O523 .
;  	#include Proj_Dir\PCPWM_3F\Sin4_3_dW12.inc;        17%
; 25/01/2020   8+1   / 12    'Sin T_123_16'!N5:N1035 .
; 07/03/2020        .

  	;#include Proj_Dir\PCPWM_3F\Sin4_3_db9.inc;        17%
	#include Proj_Dir\PCPWM_3F\Sin4_db9.inc;   8  (0:255)    

	global	Tab_Sin3G	;  Int_PCPWM_3H_x431.inc - Interrupt.asm
Tab_Sin3G	;      128   
  	#include Proj_Dir\PCPWM_3F\Sin34_db8.inc;  8  (-127:+127)     
   #endif ;__DEBUG		;    DeBug

#else ;	PCPWM_Dbg12b	;  12  
;  	#include Proj_Dir\PCPWM_3F\CoSinTab_dW12.inc;       
; 29/12/2019   2         2      
;     -     + 17% 3 .

 #ifdef	PCPWM_3H	; 07/03/2020  
	#include Proj_Dir\PCPWM_3F\Sin4_db9.inc;   8  (0:255)    

	global	Tab_Sin3G	;  Int_PCPWM_3H_x431.inc - Interrupt.asm
Tab_Sin3G	;      128   
  	#include Proj_Dir\PCPWM_3F\Sin34_db8.inc;  8  (-127:+127)     

 #else ;#ifdef	PCPWM_3H	;    12 
  	#include Proj_Dir\PCPWM_3F\CoSin_3_dW12.inc;      17% 
 #endif;#ifdef	PCPWM_3H	;

#endif ;PCPWM_Dbg12b	;  12  

#else ; #ifdef PCPWM_CoSinus ;   -   ,    8  RC  CLC/512 .
	#include Proj_Dir\PCPWM_3F\SinTab_dW12.inc	;   .
#endif ; #ifdef PCPWM_CoSinus ;

 	errorlevel  +311 ; 	Message[311] 
 #else;	PCPWM_12b ;  8 
; 256   2  -.
  #include Proj_Dir\PCPWM_3F\SinusTable_dw_16.inc	;   -  .
 #endif ;#ifdef	PCPWM_12b ; 12    8  -   
Tab_SinEnd	;    

;      24 :
	errorlevel  -311 ; 		Message[311] 
;Message[311] C:\MICROCHIP\_PRG\RTOS_3F_4431\PCPWM_3F\SPEEDTABLE_DB.INC 65 :
; Operand of HIGH operator was larger than H'FFFF'.
	global	Table_Simples
Table_Simples	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S2.inc	; 

	global	Simples_100
Simples_100	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_100.inc	; 

; 26/05/2020   -  ;
	global	Simples_200
Simples_200	;;     256 ,    MakeSimple.bas/exe
; #include Proj_Dir\PCPWM_3F\S_200.inc	; 

; 02/02/2020   -  ;
	global	Simples_400
Simples_400	;;     256 ,    MakeSimple.bas/exe
; #include Proj_Dir\PCPWM_3F\S_400.inc	; 

; 19/01/2020   -  .
	global	Simples_800
Simples_800	;;     256 ,    MakeSimple.bas/exe
; #include Proj_Dir\PCPWM_3F\S_800.inc	; 

 	errorlevel  +311 ; 	Message[311] 

;************ PCPWM_Table end**********************
